"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var preset_exports = {};
__export(preset_exports, {
  createBabelPresetChain: () => createBabelPresetChain
});
module.exports = __toCommonJS(preset_exports);
const createBabelPresetChain = () => {
  let presets = [];
  const blacks = [];
  const preset = (name) => {
    const presetExist = presets.find((plugin) => plugin.name === name);
    const isExist = Boolean(presetExist);
    const preset2 = presetExist || {
      name,
      options: []
    };
    const tap = (options2) => {
      preset2.options = options2;
      set();
    };
    const options = () => preset2.options;
    const del = () => {
      if (isExist) {
        presets = presets.filter((preset3) => !preset3.name.includes(name));
      }
    };
    const ban = () => {
      if (!blacks.includes(name)) {
        blacks.push(name);
      }
      del();
    };
    const set = () => {
      if (blacks.includes(name)) {
        throw new Error(`Preset: ${name} has been banned!, You can't set it.`);
      }
      if (!isExist) {
        presets.push(preset2);
      }
    };
    const use = (path, options2) => {
      preset2.path = path;
      preset2.options = options2 || [];
      set();
    };
    return {
      tap,
      delete: del,
      ban,
      options,
      filter: presets.filter,
      use
    };
  };
  const toJSON = () => presets.map((preset2) => preset2.options ? [
    preset2.path || preset2.name,
    ...preset2.options
  ] : preset2.path || preset2.name);
  const merge = (other) => {
    for (const preset2 of other.presets) {
      if (preset2.path) {
        chain.preset(preset2.name).use(preset2.path, preset2.options);
      } else {
        chain.preset(preset2.name).tap(preset2.options);
      }
    }
    return chain;
  };
  const chain = {
    preset,
    presets,
    blacks,
    toJSON,
    merge
  };
  return chain;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createBabelPresetChain
});
