"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugins_exports = {};
__export(plugins_exports, {
  getPluginsChain: () => getPluginsChain
});
module.exports = __toCommonJS(plugins_exports);
var import_utils = require("@modern-js/utils");
var import_babel_chain = require("./babel-chain");
const getPluginsChain = (option) => {
  const { runEnvironments, plugins: { import: babelPluginImport, transformRuntime, styledComponentsOptions } = {}, useLegacyDecorators = true, type = "module", useTsLoader = false } = option;
  const chain = (0, import_babel_chain.createBabelChain)();
  if (runEnvironments === "node") {
    chain.plugin("babel-plugin-dynamic-import-node").use(require.resolve("../compiled/babel-plugin-dynamic-import-node"));
  }
  const { antd } = babelPluginImport || {
    antd: {
      libraryDirectory: "es"
    }
  };
  if (antd !== false) {
    const antdMajorVersion = (0, import_utils.getAntdMajorVersion)(option.appDirectory);
    if (antdMajorVersion && antdMajorVersion < 5) {
      chain.plugin("babel-plugin-import").use(require.resolve("../compiled/babel-plugin-import"), [
        {
          libraryName: "antd",
          libraryDirectory: (antd === null || antd === void 0 ? void 0 : antd.libraryDirectory) || "es",
          style: true
        },
        "import-antd"
      ]);
    }
  }
  if (useTsLoader) {
    return chain;
  }
  chain.plugin("@babel/plugin-proposal-decorators").use(require.resolve("../compiled/@babel/plugin-proposal-decorators"), [
    useLegacyDecorators ? {
      // https://github.com/nicolo-ribaudo/legacy-decorators-migration-utility
      legacy: true
    } : {
      legacy: false,
      decoratorsBeforeExport: true
    }
  ]);
  chain.plugin("@babel/plugin-transform-runtime").use(require.resolve("@babel/plugin-transform-runtime"), [
    {
      // By default, babel assumes babel/runtime version 7.0.0-beta.0,
      // explicitly resolving to match the provided helper functions.
      // https://github.com/babel/babel/issues/10261
      version: require("@babel/runtime/package.json").version,
      regenerator: true,
      // https://babeljs.io/docs/en/babel-plugin-transform-runtime#useesmodules
      // We should turn this on once the lowest version of Node LTS
      // supports ES Modules.
      useESModules: type === "module",
      // Undocumented option that lets us encapsulate our runtime, ensuring
      // the correct version is used
      // https://github.com/babel/babel/blob/090c364a90fe73d36a30707fc612ce037bdbbb24/packages/babel-plugin-transform-runtime/src/index.js#L35-L42
      // absoluteRuntime: absoluteRuntimePath,
      helpers: false,
      ...transformRuntime || {}
    }
  ]);
  chain.plugin("@babel/plugin-proposal-export-default-from").use(require.resolve("../compiled/@babel/plugin-proposal-export-default-from"));
  chain.plugin("@babel/plugin-proposal-pipeline-operator").use(require.resolve("../compiled/@babel/plugin-proposal-pipeline-operator"), [
    {
      proposal: "minimal"
    }
  ]);
  chain.plugin("@babel/plugin-proposal-partial-application").use(require.resolve("../compiled/@babel/plugin-proposal-partial-application"));
  if (styledComponentsOptions !== false) {
    chain.plugin("babel-plugin-styled-components").use(require.resolve("../compiled/babel-plugin-styled-components"), [
      styledComponentsOptions || {},
      "styled-components"
    ]);
  }
  return chain;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getPluginsChain
});
